Index: drivers/video/aty/atyfb_base.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/aty/atyfb_base.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/aty/atyfb_base.c	22 Jul 2004 19:50:23 -0000	1.1
+++ drivers/video/aty/atyfb_base.c	4 Aug 2004 01:29:59 -0000	1.2
@@ -2040,53 +2303,53 @@
     memset(&var, 0, sizeof(var));
 #ifdef CONFIG_PPC
     if (_machine == _MACH_Pmac) {
-	    /*
-	     *  FIXME: The NVRAM stuff should be put in a Mac-specific file, as it
-	     *         applies to all Mac video cards
-	     */
-	    if (mode_option) {
-		if (!mac_find_mode(&var, &info->fb_info, mode_option, 8))
-		    var = default_var;
-	    } else {
-		if (default_vmode == VMODE_CHOOSE) {
-		    if (M64_HAS(G3_PB_1024x768))
-			/* G3 PowerBook with 1024x768 LCD */
-			default_vmode = VMODE_1024_768_60;
-		    else if (machine_is_compatible("iMac"))
-			default_vmode = VMODE_1024_768_75;
-		    else if (machine_is_compatible("PowerBook2,1"))
-			/* iBook with 800x600 LCD */
-			default_vmode = VMODE_800_600_60;
-		    else
-			default_vmode = VMODE_640_480_67;
-		    sense = read_aty_sense(info);
-		    printk(KERN_INFO "atyfb: monitor sense=%x, mode %d\n",
-			   sense, mac_map_monitor_sense(sense));
-		}
-		if (default_vmode <= 0 || default_vmode > VMODE_MAX)
-		    default_vmode = VMODE_640_480_60;
+            /*
+             *  FIXME: The NVRAM stuff should be put in a Mac-specific file, as it
+             *         applies to all Mac video cards
+             */
+            if (mode_option) {
+                if (!mac_find_mode(&var, &info->fb_info, mode_option, 8))
+                    var = default_var;
+            } else {
+                if (default_vmode == VMODE_CHOOSE) {
+                    if (M64_HAS(G3_PB_1024x768))
+                        /* G3 PowerBook with 1024x768 LCD */
+                        default_vmode = VMODE_1024_768_60;
+                    else if (machine_is_compatible("iMac"))
+                        default_vmode = VMODE_1024_768_75;
+                    else if (machine_is_compatible("PowerBook2,1"))
+                        /* iBook with 800x600 LCD */
+                        default_vmode = VMODE_800_600_60;
+                    else
+                        default_vmode = VMODE_640_480_67;
+                    sense = read_aty_sense(info);
+                    printk(KERN_INFO "atyfb: monitor sense=%x, mode %d\n",
+                           sense, mac_map_monitor_sense(sense));
+                }
+                if (default_vmode <= 0 || default_vmode > VMODE_MAX)
+                    default_vmode = VMODE_640_480_60;
 #ifdef CONFIG_NVRAM
-		if (default_cmode == CMODE_NVRAM)
-		    default_cmode = nvram_read_byte(NV_CMODE);
+                if (default_cmode == CMODE_NVRAM)
+                    default_cmode = nvram_read_byte(NV_CMODE);
 #endif
-		if (default_cmode < CMODE_8 || default_cmode > CMODE_32)
-		    default_cmode = CMODE_8;
-		if (mac_vmode_to_var(default_vmode, default_cmode, &var))
-		    var = default_var;
-	    }
+                if (default_cmode < CMODE_8 || default_cmode > CMODE_32)
+                    default_cmode = CMODE_8;
+                if (mac_vmode_to_var(default_vmode, default_cmode, &var))
+                    var = default_var;
+            }
     }
     else if (!fb_find_mode(&var, &info->fb_info, mode_option, NULL, 0, NULL, 8))
-	var = default_var;
+        var = default_var;
 #else /* !CONFIG_PPC */
 #ifdef __sparc__
     if (mode_option) {
-    	if (!fb_find_mode(&var, &info->fb_info, mode_option, NULL, 0, NULL, 8))
-	    var = default_var;
+        if (!fb_find_mode(&var, &info->fb_info, mode_option, NULL, 0, NULL, 8))
+            var = default_var;
     } else
-	var = default_var;
+        var = default_var;
 #else
     if (!fb_find_mode(&var, &info->fb_info, mode_option, NULL, 0, NULL, 8))
-	var = default_var;
+        var = default_var;
 #endif /* !__sparc__ */
 #endif /* !CONFIG_PPC */
 #endif /* !MODULE */
@@ -2096,49 +2359,66 @@
         var.accel_flags |= FB_ACCELF_TEXT;
 
     if (var.yres == var.yres_virtual) {
-	u32 vram = (info->total_vram - (PAGE_SIZE << 2));
-	var.yres_virtual = ((vram * 8) / var.bits_per_pixel) / var.xres_virtual;
-	if (var.yres_virtual < var.yres)
-		var.yres_virtual = var.yres;
+        u32 vram = (info->total_vram - (PAGE_SIZE << 2));
+        var.yres_virtual = ((vram * 8) / var.bits_per_pixel) / var.xres_virtual;
+        if (var.yres_virtual < var.yres)
+                var.yres_virtual = var.yres;
     }
 
-    if (atyfb_decode_var(&var, &info->default_par, info)) {
-	printk("atyfb: can't set default video mode\n");
-	return 0;
+    monitors_enabled = atyfb_monitors_enabled(info);
+
+    if (atyfb_decode_var(&var, &info->default_par, info, monitors_enabled)) {
+        printk("atyfb: can't set default video mode\n");
+        return 0;
     }
 
 #ifdef __sparc__
     atyfb_save_palette(&info->fb_info, 0);
 #endif
     for (j = 0; j < 16; j++) {
-	k = color_table[j];
-	info->palette[j].red = default_red[k];
-	info->palette[j].green = default_grn[k];
-	info->palette[j].blue = default_blu[k];
+        k = color_table[j];
+        info->palette[j].red = default_red[k];
+        info->palette[j].green = default_grn[k];
+        info->palette[j].blue = default_blu[k];
     }
 
 #ifdef CONFIG_FB_ATY_CT
     if (curblink && M64_HAS(INTEGRATED)) {
-	info->cursor = aty_init_cursor(info);
-	if (info->cursor) {
-	    info->dispsw.cursor = atyfb_cursor;
-	    info->dispsw.set_font = atyfb_set_font;
-	}
+        info->cursor = aty_init_cursor(info);
+        if (info->cursor) {
+            info->dispsw.cursor = atyfb_cursor;
+            info->dispsw.set_font = atyfb_set_font;
+        }
     }
 #endif /* CONFIG_FB_ATY_CT */
 
     atyfb_set_var(&var, -1, &info->fb_info);
 
     if (register_framebuffer(&info->fb_info) < 0)
-	return 0;
+        return 0;
 
     info->next = fb_list;
     fb_list = info;
 
     printk("fb%d: %s frame buffer device on %s\n",
-	   GET_FB_IDX(info->fb_info.node), atyfb_name, name);
+           GET_FB_IDX(info->fb_info.node), atyfb_name, name);
     return 1;
 }
+						    
+void __init aty_init_register_array(struct fb_info_aty *info)
+{
+    u32 **p, **q;
+    u32 *i;
+
+    i = (u32 *) info->ati_regbase;
+    p = (u32 **) info->ati_regaddr;
+    q = p + 256;
+    do {
+        *p = i;
+        i++;
+        p++;
+    } while (p != q);
+};
 
 int __init atyfb_init(void)
 {
